/* ICeCoffEE */

#import "ICeCoffEESuper.h"
#import "ICeCoffEEShared.h"
#import "ICeCoffEEConfig.h"

#define ICCF_OSErrAssert(err, context) NSAssert(err == noErr || err == userCanceledErr, ICCF_ErrString(err, context));
#define ICCF_OSErrCAssert(err, context) NSCAssert(err == noErr || err == userCanceledErr, ICCF_ErrString(err, context));

// search for: (?<!ICCF_LocalizedString\()(?<!ICLog\()(?<!ICapeprintf("\()(?<!%)(@"(?!Internal error: )[^"]+") replace with: ICCF_LocalizedString(\1)
#define ICCF_LocalizedString(key) \
    [(NSString *)CFBundleCopyLocalizedString(ICCF_bundle, (CFStringRef)(key), CFSTR(""), NULL) autorelease]

// XXX temporary for 1.5 development; gone when we remove Internet Config dependency
ICInstance ICCF_GetInst();
void ICCF_StartIC();
void ICCF_StopIC();

// returns an explanation for the provided OSStatus in the supplied
// if nil is returned, the error is harmless (e.g., user cancelled)
NSString *ICCF_ErrString(OSStatus err, NSString *context);

// handles an exception as specified by ICError* preferences
// if NO is returned, the exception is harmless (e.g., user cancelled)
BOOL ICCF_HandleException(NSException *e);

// returns YES if the event is a command-mouse down
BOOL ICCF_EventIsCommandMouseDown(NSEvent *e);

// returns the action determined by the event's keyboard modifiers
iccfURLAction ICCF_KeyboardAction(NSEvent *e);

// throws an exception if the URL range is nonexistent or too big 
void ICCF_CheckRange(NSRange range);

// calls ICCF_DoURLAction
// returns YES unless the user cancelled
BOOL ICCF_LaunchURL(NSString *string, iccfURLAction action);

// launch URL from on selected text view cursor position or selection
void ICCF_LaunchURLFromTextView(NSTextView *self, NSEvent *triggeringEvent);

// returns contextual menu with Services item added, if selected
NSMenu *ICCF_MenuForEvent(NSView *self, NSMenu *contextMenu, NSEvent *e);

// adds or removes services menu in menu bar
void ICCF_AddRemoveServicesMenu();

@interface ICeCoffEE : ICeCoffEESuper

@end
